//
//  PhidgetDictionaryScanner.m
//  BoardRoom
//
//  Created by Phidgets on 2017-02-17.
//  Copyright © 2017 Phidgets. All rights reserved.
//

#import "PhidgetDictionaryScanner.h"

#define LENGTH 1024
#define NUM_KEYS 1
@implementation PhidgetDictionaryScanner
+(NSMutableDictionary *)scan:(PhidgetDictionaryHandle)dictionary{
    NSMutableArray *keysArray = [[NSMutableArray alloc] init];
    NSMutableArray *valuesArray = [[NSMutableArray alloc] init];
	char buffer[LENGTH];
	
    do {
        const char *lastString = (const char *)[[keysArray lastObject] cStringUsingEncoding:NSASCIIStringEncoding];
		buffer[0] = '\0';
        if(PhidgetDictionary_scan(dictionary, lastString, buffer, LENGTH))
			break;
		
		if(strlen(buffer) == 0)
            break;
		
		NSArray *keys = [[NSString stringWithUTF8String:buffer] componentsSeparatedByString:@"\n"];
		for (id key in keys) {
			if ([key length] == 0)
				continue;
			[keysArray addObject:key];
		}
    } while(true);
    
    for (int i = 0; i < keysArray.count; i++) {
        char value[LENGTH];
        const char *key = (const char*)[[keysArray objectAtIndex:i] cStringUsingEncoding:NSASCIIStringEncoding];
        PhidgetDictionary_get(dictionary, key, value, LENGTH);
        [valuesArray addObject:[NSString stringWithFormat:@"%@",[NSString stringWithUTF8String:value]]];
    }
	
    NSMutableDictionary *pairs = [[NSMutableDictionary alloc] initWithObjects:valuesArray forKeys:keysArray];
    return pairs;
}
@end
